image: node:15.4-alpine

stages:
  - build
  - test
  - publish

variables:
  MINIDOC_SOURCE: $MINIDOC_PACKAGES_SOURCE:_authToken

build:
  stage: build
  before_script:
    - npm version
    - npm install
  script:
    - npm run build

test:
  stage: test
  before_script:
    - npm version
    - npm install
  script:
    - npm run test -- --ci --coverage
  allow_failure: true
  artifacts:
    when: always
    reports:
      junit:
        - junit.xml
      cobertura:
        - coverage/cobertura-coverage.xml

publish:
  stage: publish
  when: manual
  before_script:
    - npm version
    - npm install
  script:
    - echo $MINIDOC_SOURCE=$MINIDOC_PACKAGES_TOKEN >> .npmrc
    - CI=false npm run build
    - npm publish
  only:
    - master